\begin{figure}[t!]
  \begin{center}
 {\footnotesize
    \[
\begin{array}{llcl}
  \text{(Program)} & \mathit{\Prog} &::= & \mathit{data}^* ~\mathit{method}^* \\
  \text{(Data Struct.)} & \mathit{data} &::= & \btt{struct} ~d ~\{~ \mathit{(t~f)}^* ~\}
  \\
  \text{(Method Def.)} & \mathit{method} &::= & t ~ \mathit{mn}
  ( (\btt{ref}~ t~v)^*,(t~v)^*)
  (\btt{requires}~\pre ~~
  \btt{ensures} ~\post;)^*
  \code{ \{e\} }
  \\
  \text{(Types)} & t &::= & \code{d} ~|~ \tau
  \\
  \text{(Primitive Types)} &\tau &::= & \code{ int ~|~ bool ~|~ float ~|~ void}
  \\
  \text{(Expressions)} & \code{e} &::= &\code{
    \cnil~|~k^{\tau} ~|~ v
    ~|~ \btt{new}~d(v^*) %\\
    ~|~ t~v;~e
    ~|~ v.f
    ~|~ \mathit{mn}(v^*)
%    ~|~ \btt{\ccskip}
}
  \\
  &&& \code{
    |~ v {:=} e ~|~ v.f {:=} e
    ~|~ e ; e
    % ~|~ e \cpar e
    ~|~ \myif{b}{e}{e}
    ~|~ \btt{return}~e
    \hide{~|~\mybind{v}{(v_1,..,v_n)}{e}}}
  \\
  \text{(Boolean Expr.)} &\code{b} &::= &
  \code{ e{==}e  ~|~  !(b) ~|~ b \& b ~|~ b|b }\\
  &&&\\
  \multicolumn{4}{c}{\text{where \code{k^{\tau}} is a
      constant of type \code{\tau}, \code{v} is a variable,
      \code{f} denotes a field,
      and \emph{mn} is a method's name.}}

\end{array}
\]
\hrule
}
\end{center}
\caption{A Core Imperative Language. % \asay{add new/malloc/free}
}\label{fig.prelim.lang.syntax}
\end{figure}

\anay{what about malloc and dispose?}



%%% Local Variables:
%%% mode: latex
%%% TeX-master: "../main"
%%% End:
